<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeadlineByProductType ArrayType
 * @subpackage Arrays
 */
class ArrayOfDeadlineByProductType extends AbstractStructArrayBase
{
    /**
     * The DeadlineByProductType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeadlineByProductType[]
     */
    public $DeadlineByProductType;
    /**
     * Constructor method for ArrayOfDeadlineByProductType
     * @uses ArrayOfDeadlineByProductType::setDeadlineByProductType()
     * @param \StructType\DeadlineByProductType[] $deadlineByProductType
     */
    public function __construct(array $deadlineByProductType = array())
    {
        $this
            ->setDeadlineByProductType($deadlineByProductType);
    }
    /**
     * Get DeadlineByProductType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeadlineByProductType[]|null
     */
    public function getDeadlineByProductType()
    {
        return isset($this->DeadlineByProductType) ? $this->DeadlineByProductType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeadlineByProductType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeadlineByProductType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeadlineByProductTypeForArrayConstraintsFromSetDeadlineByProductType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeadlineByProductTypeDeadlineByProductTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeadlineByProductTypeDeadlineByProductTypeItem instanceof \StructType\DeadlineByProductType) {
                $invalidValues[] = is_object($arrayOfDeadlineByProductTypeDeadlineByProductTypeItem) ? get_class($arrayOfDeadlineByProductTypeDeadlineByProductTypeItem) : sprintf('%s(%s)', gettype($arrayOfDeadlineByProductTypeDeadlineByProductTypeItem), var_export($arrayOfDeadlineByProductTypeDeadlineByProductTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeadlineByProductType property can only contain items of type \StructType\DeadlineByProductType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeadlineByProductType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeadlineByProductType[] $deadlineByProductType
     * @return \ArrayType\ArrayOfDeadlineByProductType
     */
    public function setDeadlineByProductType(array $deadlineByProductType = array())
    {
        // validation for constraint: array
        if ('' !== ($deadlineByProductTypeArrayErrorMessage = self::validateDeadlineByProductTypeForArrayConstraintsFromSetDeadlineByProductType($deadlineByProductType))) {
            throw new \InvalidArgumentException($deadlineByProductTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($deadlineByProductType) || (is_array($deadlineByProductType) && empty($deadlineByProductType))) {
            unset($this->DeadlineByProductType);
        } else {
            $this->DeadlineByProductType = $deadlineByProductType;
        }
        return $this;
    }
    /**
     * Add item to DeadlineByProductType value
     * @throws \InvalidArgumentException
     * @param \StructType\DeadlineByProductType $item
     * @return \ArrayType\ArrayOfDeadlineByProductType
     */
    public function addToDeadlineByProductType(\StructType\DeadlineByProductType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeadlineByProductType) {
            throw new \InvalidArgumentException(sprintf('The DeadlineByProductType property can only contain items of type \StructType\DeadlineByProductType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeadlineByProductType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeadlineByProductType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeadlineByProductType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeadlineByProductType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeadlineByProductType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeadlineByProductType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeadlineByProductType
     */
    public function getAttributeName()
    {
        return 'DeadlineByProductType';
    }
}
